  'Debug.Str(string(""))
  'Debug.Str(string("",13))
  'Debug.Dec()
  'Debug.Rx()
  'Debug.Tx()

CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000

  'defining constants makes code selfexplaining
  'see line with Debug.Start(.... 
  DebugTx_Pin = 30
  DebugRx_Pin = 31
  Baudrate    = 115200
  FDX_Mode    = 0
  'and there will be only ONE place where to change values   
  
VAR
  byte MyByte
  long Mylong
  long Count 
  
OBJ
  Debug   : "FullDuplexSerialPlus"

  
PUB Main

  Debug.Start(DebugRx_Pin,DebugTx_Pin,FDX_Mode,Baudrate)

  Debug.Str(string("FullDuplexSerialPlus-Driver started with ",13))
  Debug.Str(string("Start(DebugRx_Pin="))
  Debug.Dec(DebugRx_Pin)
  Debug.Str(string(",DebugTx_Pin="))
  Debug.Dec(DebugTx_Pin)
  Debug.Str(string(",FDX_Mode="))
  Debug.Dec(FDX_Mode)
  Debug.Str(string(",Baudrate="))
  Debug.Dec(Baudrate)
  Debug.Str(string(13,13))

  repeat 
    WaitCnt(ClkFreq + cnt)

    Demo_Set_Clear_Bits_in_a_Long    
   

PUB Demo_Set_Clear_Bits_in_a_Byte    
    repeat Count from 1 to 8
      WaitCnt(ClkFreq + cnt)
      Debug.Str(string("Set BitNo "))
      Debug.Dec(Count)
      Debug.Tx(13)

      SetBitOfByte(@MyByte,Count)
      Debug.Str(string("       87654321",13))
      Debug.Str(string("MyByte="))
      Debug.Bin(MyByte,8)
      Debug.Tx(13)
      
    repeat Count from 1 to 8
      WaitCnt(ClkFreq + cnt)
      Debug.Str(string("Clear BitNo "))
      Debug.Dec(Count)
      Debug.Tx(13)

      ClearBitOfByte(@MyByte,Count)
      Debug.Str(string("       87654321",13))
      Debug.Str(string("MyByte="))
      Debug.Bin(MyByte,8)
      Debug.Tx(13)


PUB Demo_Set_Clear_Bits_in_a_Long    
    repeat Count from 1 to 32
      WaitCnt(ClkFreq + cnt)
      Debug.Str(string("Set BitNo "))
      Debug.Dec(Count)
      Debug.Tx(13)

      SetBitOfLong(@MyLong,Count)
      Debug.Str(string("       87654321876543218765432187654321",13))
      Debug.Str(string("MyLong="))
      Debug.Bin(MyLong,32)
      Debug.Tx(13)
      
    repeat Count from 1 to 32
      WaitCnt(ClkFreq + cnt)
      Debug.Str(string("Clear BitNo "))
      Debug.Dec(Count)
      Debug.Tx(13)

      ClearBitOfLong(@MyLong,Count)
      Debug.Str(string("       87654321876543218765432187654321",13))
      Debug.Str(string("MyLong="))
      Debug.Bin(MyLong,32)
      Debug.Tx(13)
       
       

Pub SetBitOfByte(PointerToByte, BitNo) | BitInByte

  'if value of BitNo is within the range of a byte (1..8) execute command 
  if (BitNo > 0) and (BitNo < 9) 
    BitInByte := 1                        'set bit number 0 to "1" 
    BitInByte := BitInByte << (BitNo - 1) 'shift this "1" to bit number BitNo 

    byte[PointerToByte] := byte[PointerToByte] | BitInByte   


Pub ClearBitOfByte(PointerToByte, BitNo) | BitInByte

  if (BitNo > 0) and (BitNo < 9)
    BitInByte := 1
    BitInByte := BitInByte << (BitNo - 1)

    byte[PointerToByte] := byte[PointerToByte] ^ BitInByte   


Pub SetBitOfWord(PointerToWord, BitNo) | BitInWord

  if (BitNo > 0) and (BitNo < 17)
    BitInWord := 1
    BitInWord := BitInWord << (BitNo - 1)

    word[PointerToWord] := word[PointerToWord] | BitInWord   


Pub ClearBitOfWord(PointerToWord, BitNo) | BitInWord

  if (BitNo > 0) and (BitNo < 17)
    BitInWord := 1
    BitInWord := BitInWord << (BitNo - 1)

    word[PointerToWord] := word[PointerToWord] ^ BitInWord   


Pub SetBitOfLong(PointerToLong, BitNo) | BitInLong

  if (BitNo > 0) and (BitNo < 33)
    BitInLong := 1
    BitInLong := BitInLong << (BitNo - 1)

    long[PointerToLong] := long[PointerToLong] | BitInLong   


Pub ClearBitOfLong(PointerToLong, BitNo) | BitInLong

  if (BitNo > 0) and (BitNo < 33)
    BitInLong := 1
    BitInLong := BitInLong << (BitNo - 1)

    long[PointerToLong] := long[PointerToLong] ^ BitInLong   

